import argparse

def parseArg():
	parser = argparse.ArgumentParser()
	parser.add_argument('base', help='base value')
	parser.add_argument('size', help='data size')
	parser.add_argument('fname', help='file name')

	params = parser.parse_args()

	return params

def lfsr(value):
	n = (value ^ (value >> 2) ^ (value >> 3) ^ (value >> 5)) & 1;
	return (value >> 1) | (n << 15)

def main():
	# 引数を解析
	params = parseArg()

	base_value = int(params.base)
	data_size = int(params.size)
	file_name = params.fname

	with open(file_name, 'w') as f:
		value = 0x5500 | (base_value & 255)
		count = 0
		for i in range(data_size>>1):
			value = lfsr(value)
			if (count % 8) == 0:
				f.write(f'\t.dw\t')
			else:
				f.write(f',')
			f.write(f'${value:04x}')
			if (count % 8) == 7:
				f.write(f'\n')
			count += 1
		if (count % 8) != 0:
			f.write(f'\n')

main()
